-- 限时特惠礼包
Lua_LimitSpecialGiftWindow = class("Lua_LimitSpecialGiftWindow", Lua_Window);
function Lua_LimitSpecialGiftWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_LimitSpecialGiftWindow";
	self.skinName = "LimitSpecialGiftWindow_skin";
	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER;
	self.showBlackMask = true;
	self.isClickClose = true;
	self.showCloseText = true;
	self.closeTextPosY = -560;
end

function Lua_LimitSpecialGiftWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.leftTimesTxt:setEnable(false);
	self.giftItemArr = Array();

	self.scrollContainer = UICreate.createScrollContainer(self.content, 0, 0, 560, 191); -- 父节点,x,y,宽,高
	self.scrollContainer.horizontal = false; -- 水平
	self.scrollContainer.vertical = false; -- 垂直
	self.scrollContainer.movementTypeValue = 1; -- 0不限制 会超出设置宽(水平)高(垂直) 1弹性 超出会回弹 2硬限制 不会超出设置宽(水平)高(垂直)
	self.scrollContainer.elasticity = 0.3; -- 弹性
	self.scrollContainer.inertia = true; -- 惯性
	self.scrollContainer:setScrollSize(0, 0); -- content 的 RectTransform 的 sizeDelta
	self.scrollContainer:setScrollPivot(4); -- content 的 RectTransform 的 pivot
	self.scrollContainer:setScrollAnchor(0.5, 0.5, 0.5, 0.5); -- content 的 RectTransform 的 anchor
	self.scrollContainer:setScrollPosition(0, 0, 0); -- content 的 RectTransform 的 pos
	-- self.scrollContainer:addMousDownFuntion(self, self.onMouseDownFun); -- 按下监听
	-- self.scrollContainer:addMouseUpFuntion(self, self.onMouseUpFun); -- 抬起监听
	self.scrollContainer:addMask(); -- 隐藏其他区域
	self.sub = self.scrollContainer.scrollContent; -- content
	LuaUtil.setObjPos(self.scrollContainer.mainContent, 9, -107, 0);

	self.sloganNum = Lua_NumberImage.new(self.content);
	self.sloganNum.pivot = 1;
	self.sloganNum.scaleVal = 0.24;
	-- self.sloganNum.numOffsetX = -1;
	self.sloganNum.numAtlas = "number";
	self.sloganNum.preStr = "xui_xslb_number1_";

	self.mainBtnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
	self.mainBtnList:setButtonCell(Lua_LimitSpecialGiftMainBtnItem);
	self.mainBtnList:setButtonItem(36, 30);
	self.mainBtnList:setClickCallBack(self, self.onMainBtnClick);
	self.mainBtnList:setLocation(0, -474, 0);

	self.subBtnList = Lua_DragList.new(self.content, 680, 102, Lua_AxisDefine.Horizontal);
	-- self.subBtnList.clickMoveOffset = 1;
	self.subBtnList:setListCell(Lua_LimitSpecialGiftSubBtnItem, 312, 102, 1);
	self.subBtnList:setCellSpacing(16, 0);

	self.portraitImg:addClickFuntion(self, self.onWinBgClick);
	self.fightBtn:addClickFuntion(self, self.onFightBtnClick);
	self.leftIcon:addClickFuntion(self, self.onLeftBtnClick);
	self.rightIcon:addClickFuntion(self, self.onRightBtnClick);
	self.buyBtn:addClickFuntion(self, self.onBuyClick);

	self:startIconTween();

	self:addLuaEvent("ON_LIMITSPECIALGIFT_ITEM_SELECT", self, self.onSubBtnClick);
	self:addLuaEvent("UPDATE_LIMITSPECIALGIFT_INFO", self, self.updateShowInfo);
end

function Lua_LimitSpecialGiftWindow:showWin(param)
	self:superCall("showWin", param); -- 按钮打开默认传1

	local arr = DataCenter.limitSpecialGiftData.limitStageArr;
	if arr:getSize() <= 0 then -- 全部礼包都已经结束
		OperateAlert.showLangValue(793000);
		self:hide();
	else
		local selectIdx = self:getSelectIdx(arr, param, 1);
		self:setMainBtnInfo(arr, selectIdx);
	end
end

-- 获取选中索引，并且设置是否当前界面显示的活动
function Lua_LimitSpecialGiftWindow:getSelectIdx(arr, giftId, selectType)
	local limitVo = DataCenter.limitSpecialGiftData:getLimitSpecialGiftVo(giftId);
	local selectIdx = 1;
	if limitVo then
		for i = 1, arr:getSize() do
			if selectType == 1 then -- 一级页签
				if arr[i] == limitVo.giftStage then
					selectIdx = i;
					break;
				end
			elseif selectType == 2 then -- 二级页签
				if arr[i] == limitVo.id then
					selectIdx = i;
					break;
				end
			end
		end
	end
	return selectIdx;
end

function Lua_LimitSpecialGiftWindow:setMainBtnInfo(arr, showIdx)
	self.showMainIdx = showIdx;
	self.showMainLen = arr:getSize();
	self.mainBtnList:setEnable(arr:getSize() > 1);
	self.mainBtnList:setData(arr);
	self.mainBtnList:setSelected(showIdx);
end

function Lua_LimitSpecialGiftWindow:onMainBtnClick(index, giftStage)
	self.isMoveTween = false; -- 点击一级不需要播放动画
	self.leftIcon:setEnable(self.showMainIdx > 1);
	self.rightIcon:setEnable(self.showMainIdx < self.showMainLen);

	local arr = DataCenter.limitSpecialGiftData:getGiftShowArr(giftStage); -- 切换一级页签，重新加载二级页签
	local item;
	for i = 1, arr:getSize() do
		item = self.giftItemArr[i];
		if item == nil then
			item = Lua_LimitSpecialGiftRewardItem.new(self.sub);
			self.giftItemArr:add(item);
		end
		item.contentName = "Lua_LimitSpecialGiftRewardItem_" .. i;
		item:setData(arr[i]);
		item:setLocation((i - 1) * 600, 0, 0);
	end

	local giftId = self.showData and self.showData or self.limitVo.id;
	local posX = arr:getSize() > 2 and 0 or (680 - arr:getSize() * 328 + 16) / 2;
	local showSubIdx = self:getSelectIdx(arr, giftId, 2);
	self.subBtnList.canDrag = arr:getSize() > 2;
	self.subBtnList:setArrayData(arr);
	self.subBtnList:setLocation(posX, -283, 0);
	self.subBtnList:moveToIndex(showSubIdx, true);
	self.subBtnList:setSelected(showSubIdx);
	self.subBtnList:setSelectClick(showSubIdx);
	self.showData = nil;
end

function Lua_LimitSpecialGiftWindow:playLTTween(showSubIdx, isMove)
	self.isMoveTween = true;
	if self.preSubIdx == showSubIdx then
		return;
	end
	self.preSubIdx = showSubIdx;

	self:stopLTTween();
	local posX = -(showSubIdx - 1) * 600;
	if isMove then
		TweenUtil.getInstance():addTweenTargetPos(self.sub, 2, 0, posX, 0, 0, self, self.stopLTTween, 0, false);
	else
		LuaUtil.setObjPos(self.sub, posX, 0, 0);
	end
end

function Lua_LimitSpecialGiftWindow:stopLTTween()
	TweenUtil.getInstance():stop(self.sub);
end

function Lua_LimitSpecialGiftWindow:onSubBtnClick(subItemData)
	local giftId = subItemData.giftId;
	local isRefresh;
	if self.showData or self.isMoveTween then -- 新触发和点击二级不刷新
		isRefresh = false;
	else
		isRefresh = DataCenter.limitSpecialGiftData.isRefreshEndGift;
		if isRefresh then -- 刷新时获取新礼包id
			local arr = DataCenter.limitSpecialGiftData.limitStageArr;
			local selectIdx = self:getSelectIdx(arr, self.limitVo.id, 1);
			if self.isLeft then
				selectIdx = selectIdx > 1 and selectIdx -1 or selectIdx;
			else
				selectIdx = selectIdx < arr:getSize() and selectIdx + 1 or selectIdx;
			end
			giftId = DataCenter.limitSpecialGiftData:getGiftShowArr(arr[selectIdx])[1];
		end
	end
	self.limitVo = DataCenter.limitSpecialGiftData:getLimitSpecialGiftVo(giftId);
	self:playLTTween(subItemData.showSubIdx, self.isMoveTween);
	self:updateShowInfo(isRefresh);
end

function Lua_LimitSpecialGiftWindow:updateShowInfo(bChange)
	local arr = DataCenter.limitSpecialGiftData.limitStageArr;
	if bChange and arr:getSize() > 0 then
		DataCenter.limitSpecialGiftData.isRefreshEndGift = false;
		local selectIdx = self:getSelectIdx(arr, self.limitVo.id, 1);
		self:setMainBtnInfo(arr, selectIdx);
	else
		self:updateShowGiftInfo();
	end
end

function Lua_LimitSpecialGiftWindow:updateShowGiftInfo()
	self.portraitImg:SetDimensions(0, 0);
	self.portraitImg:setUrl(nil);
	self.portraitImg:setUrl(self.limitVo.portraitUrl);
	self.portraitImg:setLocation(self.limitVo.portraitPos[1], self.limitVo.portraitPos[2], self.limitVo.portraitPos[3]);
	self.winBg:SetDimensions(0, 0);
	self.winBg:setUrl(nil);
	self.winBg:setUrl(self.limitVo.bgUrl);
	self.winBg:setLocation(self.limitVo.bgPos[1], self.limitVo.bgPos[2], self.limitVo.bgPos[3]);

	self.itemIcon:setAltas(self.limitVo.showIcon[1], self.limitVo.showIcon[2]);
	self.itemIcon:setScale(self.limitVo.showIconScale, self.limitVo.showIconScale)
	self.desIcon_1:setAltas(self.limitVo.titleIcon_1[1], self.limitVo.titleIcon_1[2]);
	self.desIcon_2:setAltas(self.limitVo.titleIcon_2[1], self.limitVo.titleIcon_2[2]);
	self.desIcon_1:setLocation(self.limitVo.titlePos_1[1], self.limitVo.titlePos_1[2], self.limitVo.titlePos_1[3]);
	self.desIcon_2:setLocation(self.limitVo.titlePos_2[1], self.limitVo.titlePos_2[2], self.limitVo.titlePos_2[3]);
	self.desIcon_1:resetSize();
	self.desIcon_2:resetSize();
	self.itemIcon:setEnable(self.limitVo.isShowIcon);
	self.fightBtn:setEnable(self.limitVo.recordId ~= 0);

	local colorStr = self.limitVo.leftTimes > 0 and "FFFFFF" or "C62A0F";
	self.leftTimesTxt.text = LanUtil.formateStr(793001, colorStr, times, self.limitVo.totalTimes);

	self.sloganNum.num = self.limitVo.sloganValue;
	local totalWidth = self.sloganNum.totalWidth + self.sloganIcon.width;
	self.sloganNum:setLocation(-totalWidth / 2, -359.5, 0);
	self.sloganIcon:setLocation(self.sloganNum.posX + self.sloganNum.totalWidth + 1, -359.5, 0);

	if self.limitVo.leftTimes > 0 then
		if self.limitVo.endTime > 0 then
			self.buyBtn.label = LanUtil.formateStr(793002, self.limitVo.money);
		else
			self.buyBtn:setLangValue(793003); -- 已失效
		end
	else
		self.buyBtn:setLangValue(793004); -- 已购买
	end
	self:startTimer();
	self:updateLeftTime();
end

function Lua_LimitSpecialGiftWindow:startIconTween()
	self.startTime = getTime();
	self:addTimer("Lua_LimitSpecialGiftWindow_itemIcon", 0.03, self, self.onIconTween);
end

function Lua_LimitSpecialGiftWindow:onIconTween()
	local pt = (getTime() - self.startTime) * 3;
	self.itemIcon:setLocation(13, 266 + 5 * Mathf.Sin(pt), 0);
end

function Lua_LimitSpecialGiftWindow:startTimer()
	if self.countDown ~= true then
		self.countDown = true;
		Lua_CommonUtil.addTimer("Lua_LimitSpecialGiftWindow_time", 1, self, self.updateLeftTime);
	end
end

function Lua_LimitSpecialGiftWindow:updateLeftTime()
	local time = self.limitVo.endTime;
	self.timeTxt.text = LanUtil.formateStr(793005, Lua_TimeTransform.transSeconds6(time, true, true, true));
	if time <= 0 then
		self.timeTxt:setLangValue(793000);
		self:endTimer();
	end
end

function Lua_LimitSpecialGiftWindow:endTimer()
	if self.countDown == true then
		self.countDown = false;
		Lua_CommonUtil.removeTimer(self, self.updateLeftTime);
	end
end

function Lua_LimitSpecialGiftWindow:onFightBtnClick(go)
	Lua_ProxyManager.getProxy("Lua_FightProxy"):sFightReplay(self.limitVo.recordId, nil, nil, nil, 0);
end

function Lua_LimitSpecialGiftWindow:onLeftBtnClick(go)
	if self.showMainIdx <= 1 then
		return;
	end
	self.isLeft = true;
	self.showMainIdx = self.showMainIdx - 1;
	self:updateRewardInfo(self.showMainIdx);
end

function Lua_LimitSpecialGiftWindow:onRightBtnClick(go)
	if self.showMainIdx >= self.showMainLen then
		return;
	end
	self.isLeft = false;
	self.showMainIdx = self.showMainIdx + 1;
	self:updateRewardInfo(self.showMainIdx);
end

function Lua_LimitSpecialGiftWindow:updateRewardInfo(index)
	local arr = DataCenter.limitSpecialGiftData.limitStageArr;
	if arr:getSize() <= 0 then -- 全部礼包都失效了
		self.leftIcon:setEnable(false);
		self.rightIcon:setEnable(false);
		self.mainBtnList:setEnable(false);
	else
		self.leftIcon:setEnable(index > 1);
		self.rightIcon:setEnable(index < self.showMainLen);
		self.mainBtnList:setSelected(index);
	end
end

function Lua_LimitSpecialGiftWindow:onBuyClick(go)
	if self.limitVo.leftTimes > 0 then
		if self.limitVo.endTime > 0 then
			local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(self.limitVo.id);
			DataCenter.sdkInterface:PointOut(1, tonumber(rechargeInfo.money), tonumber(rechargeInfo.money_type),
				tonumber(rechargeInfo.id), rechargeInfo.gift_name, rechargeInfo.gold);
		else
			OperateAlert.showLangValue(793003);
		end
	else
		OperateAlert.showLangValue(793004);
	end
end

function Lua_LimitSpecialGiftWindow:dispose()
	if self.giftItemArr ~= nil then
		self.giftItemArr:dispose();
		self.giftItemArr:clear();
		self.giftItemArr = nil;
	end
	if self.scrollContainer ~= nil then
		self.scrollContainer:dispose();
		self.scrollContainer = nil;
	end
	if self.mainBtnList ~= nil then
		self.mainBtnList:dispose();
		self.mainBtnList = nil;
	end
	if self.subBtnList ~= nil then
		self.subBtnList:dispose();
		self.subBtnList = nil;
	end
	self.sub = nil;
	self.limitVo = nil;
	self:endTimer();
	self:stopLTTween();
	self:removeTimer(self, self.onIconTween);
	DataCenter.limitSpecialGiftData:checkPopupInfo(); -- 关闭判断是否有新触发的礼包
	self:superCall("dispose");
end










Lua_LimitSpecialGiftMainBtnItem = class("Lua_LimitSpecialGiftMainBtnItem", Lua_ButtonCell)
function Lua_LimitSpecialGiftMainBtnItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_LimitSpecialGiftMainBtnItem:buildShowItem()
	self:superCall("buildShowItem");
	self.icon = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 0, 0);
end

function Lua_LimitSpecialGiftMainBtnItem:setSelected(index)
	if index == self.index then
		self.icon:setAltas("limittime_gift_atlas", "xui_xslb_widget_7");
	else
		self.icon:setAltas("limittime_gift_atlas", "xui_xslb_widget_8");
	end
end

function Lua_LimitSpecialGiftMainBtnItem:dispose()
	if self.icon ~= nil then
		self.icon:dispose();
		self.icon = nil;
	end
	self:superCall("dispose");
end










Lua_LimitSpecialGiftSubBtnItem = class("Lua_LimitSpecialGiftSubBtnItem", Lua_ListCell)
function Lua_LimitSpecialGiftSubBtnItem:ctor(p)
	self:superCall("ctor", p, "LimitSpecialGiftSubBtnItem_skin");
end

function Lua_LimitSpecialGiftSubBtnItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_LimitSpecialGiftSubBtnItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local limitVo = DataCenter.limitSpecialGiftData:getLimitSpecialGiftVo(data);
	self.itemIcon:setAltas(limitVo.showIcon[1], limitVo.showIcon[2]);
	self.nameTxt.text = limitVo.giftName;
end

function Lua_LimitSpecialGiftSubBtnItem:onPressClick()
	if self._data then
		Lua_MsgUtil.callFunc("ON_LIMITSPECIALGIFT_ITEM_SELECT", {giftId = self._data, showSubIdx = self.cellSeqIndex});
		return true;
	end
end

function Lua_LimitSpecialGiftSubBtnItem:onSelectionChange(bSelect)
	self:superCall("onSelectionChange", bSelect);
	if bSelect then
		self.itemBg:setAltas("limitspecial_gift_atlas", "xui_thxslb_toggle_001_a");
	else
		self.itemBg:setAltas("limitspecial_gift_atlas", "xui_thxslb_toggle_001_b");
	end
end

function Lua_LimitSpecialGiftSubBtnItem:dispose()
	self._data = nil;
	self:superCall("dispose");
end










Lua_LimitSpecialGiftRewardItem = class("Lua_LimitSpecialGiftRewardItem", Lua_ListCell)
function Lua_LimitSpecialGiftRewardItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_LimitSpecialGiftRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_DragList.new(self.content, 560, 191, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_LimitSpecialGiftRewardSubItem, 141, 191, 1);
	self.rewardList:setCellSpacing(12, 0);
	self:addLuaEvent("UPDATE_LIMITSPECIALGIFT_INFO", self, self.updateRewardInfo);
end

function Lua_LimitSpecialGiftRewardItem:setData(data)
	self._data = DataCenter.limitSpecialGiftData:getLimitSpecialGiftVo(data);
	if data == nil or self._data == nil then
		return;
	end

	local list = self._data.rewardItem;
	local posX = #list > 3 and 0 or (560 - #list * 153 + 12) / 2;
	self.rewardList.canDrag = #list > 3;
	self.rewardList:setArrayData(list);
	self.rewardList:setLocation(posX, 0, 0);
	self:updateRewardInfo();
end

function Lua_LimitSpecialGiftRewardItem:updateRewardInfo()
	local itemArr = self.rewardList.showDragDataList;
	for i = 1, itemArr:getSize() do
		itemArr[i].cell:setDrawState(self._data.leftTimes <= 0);
	end
end

function Lua_LimitSpecialGiftRewardItem:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self._data = nil;
	self:superCall("dispose");
end










Lua_LimitSpecialGiftRewardSubItem = class("Lua_LimitSpecialGiftRewardSubItem", Lua_ListCell);
function Lua_LimitSpecialGiftRewardSubItem:ctor(p)
	self:superCall("ctor", p, "LimitSpecialGiftRewardSubItem_skin");
end

function Lua_LimitSpecialGiftRewardSubItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setLocation(0, 33, 0);
end

function Lua_LimitSpecialGiftRewardSubItem:setData(data)
	if data == nil then
		return;
	end

	local tvo = Lua_ToolVo.createToolVo(data[1], data[2]);
	self.itemIcon:setData(tvo);
	self.nameTxt.text = data[3]; -- tvo.name;
end

function Lua_LimitSpecialGiftRewardSubItem:checkInBound(posX, posY)
	local minX = self.centerPosX + self.itemIcon.x - self.itemIcon.itemW * self.itemIcon.scaleX / 2;
	local maxX = self.centerPosX + self.itemIcon.x + self.itemIcon.itemW * self.itemIcon.scaleX / 2;
	local minY = self.centerPosY + self.itemIcon.y - self.itemIcon.itemH * self.itemIcon.scaleY / 2;
	local maxY = self.centerPosY + self.itemIcon.y + self.itemIcon.itemH * self.itemIcon.scaleY / 2;
	return posX >= minX and posX <= maxX and posY >= minY and posY <= maxY;
end

function Lua_LimitSpecialGiftRewardSubItem:onPressClick()
	self.itemIcon:onItemClick();
end

function Lua_LimitSpecialGiftRewardSubItem:setDrawState(state)
	self.itemIcon:setDrawMask(state);
end

function Lua_LimitSpecialGiftRewardSubItem:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	self:superCall("dispose");
end